<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="仓库名称" prop="name">
                    <el-input v-model="formData.name" clearable placeholder="请输入仓库名称" :readonly="false"/>
                </el-form-item>
                <el-form-item label="仓库编号" prop="code">
                    <el-input v-model="formData.code" clearable placeholder="请输入仓库编号" :readonly="false"/>
                </el-form-item>
                <el-form-item label="联系人员" prop="contacts">
                    <el-input v-model="formData.contacts" clearable placeholder="请输入联系人员" :readonly="false"/>
                </el-form-item>
                <el-form-item label="联系电话" prop="tel">
                    <el-input v-model="formData.tel" clearable placeholder="请输入联系电话" :readonly="false"/>
                </el-form-item>
                <el-form-item label="仓库地址" prop="address">
                    <el-input v-model="formData.address" clearable placeholder="请输入仓库地址" :readonly="false"/>
                </el-form-item>
                <el-form-item label="备注信息" prop="notes">
                    <el-input v-model="formData.notes" clearable placeholder="请输入备注信息" :readonly="false"/>
                </el-form-item>
                <el-form-item label="排序" prop="sort">
                    <el-input v-model="formData.sort" clearable placeholder="请输入排序" :readonly="false"/>
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="warehouseEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiWarehouseAdd, apiWarehouseEdit, apiWarehouseDetail } from '@/api/warehouse'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑仓库信息' : '新增仓库信息'
})

// 表单数据
const formData = reactive({
    id: '',
    name: '',
    code: '',
    contacts: '',
    tel: '',
    address: '',
    notes: '',
    sort: '',
})


// 表单验证
const formRules = reactive<any>({
    name: [{
        required: true,
        message: '请输入仓库名称',
        trigger: ['blur']
    }]
})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    
    
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiWarehouseDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData,  }
    mode.value == 'edit' 
        ? await apiWarehouseEdit(data) 
        : await apiWarehouseAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
